# sisendi korrektsuse kontrollija

import sys

def crossprod(p0, p1, p2):
	return (p0[0] - p1[0]) * (p0[1] - p2[1]) - (p0[0] - p2[0]) * (p0[1] - p1[1])

def dotprod(p0, p1, p2):
	return (p0[0] - p1[0]) * (p0[0] - p2[0]) + (p0[1] - p1[1]) * (p0[1] - p2[1])

def overlap(l1, l2):
	if crossprod(l1[0], l1[1], l2[0]) != 0:
		return False
	if crossprod(l1[0], l1[1], l2[1]) != 0:
		return False
	if dotprod(l1[0], l2[0], l2[1]) < 0:
		return True
	if dotprod(l1[1], l2[0], l2[1]) < 0:
		return True
	if dotprod(l2[0], l1[0], l1[1]) < 0:
		return True
	if dotprod(l2[1], l1[0], l1[1]) < 0:
		return True
	return False

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline())
if 1 > n or n > 5000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

lines = []
overlaps = 0
for i in range(n):
	x1, y1, x2, y2 = [int(_) for _ in fi.readline().split()]
	if -10000 > min(x1, y1, x2, y2) or max(x1, y1, x2, y2) > 10000:
		sys.exit('Coordinates out of range on line {0}'.format(2 + i))
	p1, p2 = (x1, y1), (x2, y2)
	if p1 == p2:
		sys.exit('Degenerate line on line {0}'.format(2 + i))
	for x in lines:
		if x == (p1, p2) or x == (p2, p1):
			sys.exit('Duplicate line on line {0}'.format(2 + i))
		if overlap(x, (p1, p2)):
			overlaps += 1
	lines.append((p1, p2))
	fo.write('{0} {1} {2} {3}\n'.format(x1, y1, x2, y2))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100 and overlaps == 0:
		print('Subtask 1')
	elif n <= 100:
		print('Subtask 2')
	elif overlaps == 0:
		print('Subtask 3')
	else:
		print('Subtask 4')
