// finds degenerate triangles that trip up floating-point calculations

#include <iostream>
#include <numeric>
#include <cmath>
using namespace std;

#ifndef number
#define number double
#endif

int main() {
	for (int xy = 1; xy < 200; ++xy) {
		cout << xy << '\n';
		for (int x = 1; x < xy; ++x) {
			int y = xy - x;
			if (x > y) continue;
			int d = gcd(x, y);
			if (d == 1) continue;
			for (int i = 1; i < d; ++i) {
				int x1 = x / d * i, y1 = y / d * i;
				int x2 = x - x1, y2 = y - y1;
				if (x1 > x2) break;
				number a1 = sqrt(x1 * x1 + y1 * y1);
				number a2 = sqrt(x2 * x2 + y2 * y2);
				number a = sqrt(x * x + y * y);
				if (a1 + a2 > a) {
					cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
				}
			}
		}
	}
}
