// naiivne lahendus kõigi lõigukolmikute läbivaatusega;
// keerukus on O(N^3), jääb suuremates testides ajahätta

// osaline lahendus, ei kontrolli lõikude kattumisi

#include <iostream>
#include <vector>
using namespace std;

struct punkt { int x, y; };

// punktide võrdlusoperaator, oma mugavuseks
bool operator==(punkt const& p1, punkt const& p2) {
	return p1.x == p2.x and p1.y == p2.y;
}

struct loik { punkt a, b; };

// kontrollib, kas kolm lõiku moodustavad kolmnurga
// ei kontrolli, et kolmnurk pole kõdunud
bool kolmnurk(loik const& l1, loik const& l2, loik const& l3) {
	if (l1.a == l2.a) {
		if (l1.b == l3.a and l2.b == l3.b)
			return true;
		if (l1.b == l3.b and l2.b == l3.a)
			return true;
	}
	if (l1.a == l2.b) {
		if (l1.b == l3.a and l2.a == l3.b)
			return true;
		if (l1.b == l3.b and l2.a == l3.a)
			return true;
	}
	if (l1.b == l2.a) {
		if (l1.a == l3.a and l2.b == l3.b)
			return true;
		if (l1.a == l3.b and l2.b == l3.a)
			return true;
	}
	if (l1.b == l2.b) {
		if (l1.a == l3.a and l2.a == l3.b)
			return true;
		if (l1.a == l3.b and l2.a == l3.a)
			return true;
	}
	return false;
}

int main() {
	int n;
	cin >> n;
	vector<loik> ll(n);
	for (auto & l : ll) {
		cin >> l.a.x >> l.a.y >> l.b.x >> l.b.y;
	}

	int m = 0;
	for (int i1 = 0; i1 < n; ++i1) {
		for (int i2 = i1 + 1; i2 < n; ++i2) {
			for (int i3 = i2 + 1; i3 < n; ++i3) {
				if (kolmnurk(ll[i1], ll[i2], ll[i3]))
					m += 1;
			}
		}
	}

	cout << m << '\n';
}
