# -- coding: utf-8 --

# efektiivne lahendus lõigupaaride läbivaatusega:
# kontrollib iga kahe lõigu jaoks, kas leidub ka
# kolmas, mis nendega kokku kolmnurga moodustab

# kasutab set andmetüüpi, millesse elementide lisamise
# ja nende sealt otsimise aeg on konstantne;
# lahenduse kogukeerukus on seega O(N^2)

# korrektne lahendus, kontrollib lõikude kattumisi
# täisarvuliste arvutustega vektorkorrutise abil ja
# väldib sellega ujukomaarvude ümardamisvigu

import sys

# arvutab p0->p1 ja p0->p2 vektorkorrutise
def vkorr(p0, p1, p2):
	dx1, dy1 = p1[0] - p0[0], p1[1] - p0[1]
	dx2, dy2 = p2[0] - p0[0],p2[1] - p0[1]
	return dx1 * dy2 - dx2 * dy1

n = int(sys.stdin.readline())
ll = set()
for i in range(n):
	x1, y1, x2, y2 = [int(_) for _ in sys.stdin.readline().split()]
	p1, p2 = (x1, y1), (x2, y2)
	ll.add((min(p1, p2), max(p1, p2)))

m = 0
for l1 in ll:
	for l2 in ll:
		if l1[0] != l2[0]:
			# need kaks lõiku ei moodusta vasakut alumist nurka
			continue
		lx = (min(l1[1], l2[1]), max(l1[1], l2[1])) 
		if lx not in ll:
			# kolmandat serva ei ole
			continue
		if vkorr(l1[0], l1[1], l2[1]) == 0:
			# punktid on ühel sirgel, kolmnurk on kõdunud
			continue
		m += 1

print(m // 2)
