#include <iostream>
#include <fstream>
#include <string>
#include <set>
#include <cstdlib> // for exit()
using namespace std;

#define done(r, m) { cout << r << '\n'; cerr << m << '\n'; exit(0); }

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	// we don't use the input file

	ifstream hint(argv[2]);
	set<string> res_hint;
	for (string t; getline(hint, t); ) {
		res_hint.insert(t);
	}

	ifstream output(argv[3]);
	if (!output) {
		done(0, "No output file");
	}
	set<string> res_out;
	for (string t; getline(output, t); ) {
		res_out.insert(t);
	}

	int pos = 0, neg = 0;
	for (const string & t : res_out) {
		if (res_hint.count(t) == 1) {
			++pos;
		} else {
			++neg;
		}
	}

	int res = pos > neg ? pos - neg : 0;
	if (res == res_hint.size()) {
		done(1, "OK");
	} else {
		done(double(res) / res_hint.size(), pos << " correct, " << neg << " incorrect lines");
	}
}
