// random string, "clever" queries

#include "testlib.h"
#include <iostream>
#include <map>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");

  cout << n << " " << m << '\n';
  string s;
  for (int i = 0; i < n; i++) {
    if (rnd.next(2) == 0) {
      s.push_back('(');
    } else {
      s.push_back(')');
    }
  }
  cout << s << '\n';
  
  vector<int> balance (n + 1, 0);
  for (int i = 1; i <= n; i++) {
    if (s[i - 1] == '(') {
      balance[i] = balance[i - 1] + 1;
    } else {
      balance[i] = balance[i - 1] - 1;
    }
  }

  map<int, vector<int>> levels;
  int minbal = 0, maxbal = 0;
  for (int i = 0; i <= n; i++) {
    levels[balance[i]].push_back(i);
    minbal = min(minbal, balance[i]);
    maxbal = max(maxbal, balance[i]);
  }

  vector<pair<int, int>> qs;
  int lvl_qc = 3 * (m / 4);
  for (int i = 0; i < lvl_qc; i++) {
    int lvl;
    do {
      lvl = rnd.next(minbal, maxbal);
    } while ((int) levels[lvl].size() < 2);

    int l, r;
    do {
      l = levels[lvl][rnd.next(levels[lvl].size())];
      r = levels[lvl][rnd.next(levels[lvl].size())];
    } while (l == r);
    if (l > r) {
      swap(l, r);
    }
    qs.push_back(make_pair(l + 1, r));
  }

  for (int i = 0; i < m - lvl_qc; i++) {
    int l, r;
    do {
      l = rnd.next(1, n);
      r = rnd.next(1, n);
    } while (l == r);

    if (l > r) {
      swap(l, r);
    }

    qs.push_back(make_pair(l, r));
  }

  shuffle(qs.begin(), qs.end());
  for (auto q : qs) {
    cout << q.first << " " << q.second << '\n';
  }
}
