#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1e6 + 5;

vector<int> ch [MAX_N];

int sta [MAX_N];
int fin [MAX_N];
int lvl [MAX_N];

string s;

vector<int> by_lvl [MAX_N];

void dfs (int u, int par, int &cur) {
  lvl[u] = 1 + lvl[par];
  
  if (u != 0) {
    sta[u] = cur;
    cur++;
    s.push_back('(');
  }

  for (int nxt : ch[u]) {
    dfs(nxt, u, cur);
  }
  
  if (u != 0) {
    fin[u] = cur;
    cur++;
    s.push_back(')');
  }
}

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int hn = opt<int>("halfn");
  int m = opt<int>("m");
  int lvllim = opt<int>("lvllim");
  int wt = opt<int>("wt");

  for (int i = 1; i < hn; i++) {
    ch[rnd.next(i)].push_back(i);
  }

  int cur = 0;
  dfs(0, 0, cur);

  vector<int> good_us;
  for (int u = 0; u < hn; u++) {
    if (lvl[u] <= lvllim && (int) ch[u].size() >= 2) {
      good_us.push_back(u);
    }
  }
  cerr << "# of good u-s = " << good_us.size() << endl;
  
  vector<pair<int, int>> qs;
  int smart_qc = 4 * (m / 5);
  for (int i = 0; i < smart_qc; i++) {
    int u = good_us[rnd.next(good_us.size())];

    int lu = rnd.wnext(ch[u].size(), -wt);
    int ru = rnd.wnext(ch[u].size(), wt);

    if (sta[ch[u][lu]] > sta[ch[u][ru]]) {
      swap(lu, ru);
    }

    qs.push_back(make_pair(sta[ch[u][lu]], fin[ch[u][ru]]));
  }

  for (int i = 1; i < hn; i++) {
    by_lvl[lvl[i]].push_back(i);
  }

  for (int i = 0; i < m - smart_qc; i++) {
    int lvl_at;
    do {
      lvl_at = rnd.next(2, lvllim + 1);
    } while ((int) by_lvl[lvl_at].size() < 2);

    int lv = by_lvl[lvl_at][rnd.wnext(by_lvl[lvl_at].size(), -wt)];
    int rv = by_lvl[lvl_at][rnd.wnext(by_lvl[lvl_at].size(), wt)];

    if (sta[lv] > sta[rv]) {
      swap(lv, rv);
    }

    qs.push_back(make_pair(sta[lv], fin[rv]));
  }

  cout << (int) s.size() << " " << m << '\n';
  cout << s << '\n';

  for (auto q : qs) {
    cout << 1 + q.first << " " << 1 + q.second << '\n';
  }
}
