#include <iostream>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

const int MAX_ITERS = 200;

bool solve (const string &s, int l, int r) {
  int lptr = l, rptr = r - 1;
  int bal = 0, rbal = 0;
  bool seen0 = false;
  int iters = 0;
  while (lptr <= rptr) {
    if (s[lptr] == '(') bal++;
    else bal--;
    if (bal < 0) return false;
    if (bal == 0 && lptr != r - 1) seen0 = true;

    if (lptr == rptr) break;

    if (s[rptr] == '(') rbal++;
    else rbal--;
    if (rbal > 0) return false;
    if (rbal == 0) seen0 = true;

    lptr++;
    rptr--;
    
    iters++;
    if (iters == MAX_ITERS) {
      return true;
    }
  }

  return seen0 && bal + rbal == 0;
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, qc;
  cin >> n >> qc;

  string s;
  cin >> s;

  for (int i = 0; i < qc; i++) {
    int l, r;
    cin >> l >> r;
    l--;

    if (solve(s, l, r)) {
      cout << "JAH" << '\n';
    } else {
      cout << "EI" << '\n';
    }
  }
}
